---
##
# retrieve and configure kolla
#
- hosts: jumphost
  vars_files:
    - "vars/idf.yml"
    - "vars/pdf.yml"
  tasks:
    - name: create security group
      os_security_group:
        cloud: "{{ openstack_user_name }}"
        state: present
        name: "{{ openstack_tenant_name }}{{ identifier }}"
        description: "security group for project {{ openstack_tenant_name }}"

    - name: create security group ingress rule
      os_security_group_rule:
        cloud: "{{ openstack_user_name }}"
        security_group: "{{ openstack_tenant_name }}{{ identifier }}"
        state: present
        remote_ip_prefix: 0.0.0.0/0
        direction: ingress

    # Either we're running on a "secured script runner" and it must have a pub
    # key, either we're not and then pub key must be given via well known
    # variable file.
    - name: get runner id_rsa.pub
      slurp:
        src: "{{ lookup('env', 'HOME') }}/.ssh/id_rsa.pub"
      delegate_to: 127.0.0.1
      register: id_rsa
      ignore_errors: true

    - name: retrieve pub key
      set_fact:
        pub_key: "{{ id_rsa['content'] | b64decode }}"
      when: not id_rsa.failed

    - name: include vaulted ssh credentials
      include_vars: "{{ inventory_dir }}/../vars/vaulted_ssh_credentials.yml"
      when: id_rsa.failed

    - name: retrieve pub key
      set_fact:
        pub_key: "{{ vault_ssh_id_rsa_pub }}"
      when: id_rsa.failed

    - name: add runner ssh key to project
      os_keypair:
        cloud: "{{ openstack_user_name }}"
        name:
          "{{ openstack_user_name   | regex_replace('[@\\.]', '_') }}_runner"
        state: present
        public_key: "{{ pub_key }}"
